using System;
using GameKnight.Core;

namespace GameKnight.GameBoy
{
	
	public sealed class Collection<T> : IIndexer where T : IIndexer
	{
			
		private readonly T[] Array = null;
		
		private readonly int Length = 0;
		
		private readonly int Mask = 0;
			
		public Collection( int Length ) : this( new T[Length] )
		{
			return;
		}
		
		public Collection( T[] Array )
		{
			this.Array = Array;
			this.Length = Array.Length;
			this.Mask = ( Length - 1 );
			return;
		}
	
		public byte this[int Address]
		{
			get
			{
				return Array[Address&Mask][Address];
			}
			set
			{
				Array[Address&Mask][Address] = value;
			}
		}
		
	}
	
}






