using System;
using GameKnight.Core;

namespace GameKnight
{
	
	namespace GameBoy
	{

		public partial class Register : IRegister
		{
			
			public sealed class IF : IRegister
			{

				private readonly IConsole Console = null;
				
				public byte Value = 0x01;
				
				public IF( IConsole Console )
				{
					this.Console = Console;
					return;
				}
				
				public byte this[int Address]
				{
					get
					{
						return (byte)( Value | 0xE0 );
					}
					set
					{
						Value = value;
						Console.InterruptMask = value;
					}
				}

			}

		}
		
	}
	
}


