﻿using System;
using Drawing = System.Drawing;
using Forms = System.Windows.Forms;
using GameKnight.Core;

namespace GameKnight.Win32
{

	//public partial class Application : IInterface
	//{
		
		public sealed class ControllerDialog : Forms.Form
		{
			
			private readonly Forms.Button OK_Button = new Forms.Button();
			
			private readonly Forms.TabControl TabControl = new Forms.TabControl();
			
			public ControllerDialog( IConsole Console, InputDevice InputDevice ) : base()
			{
				this.Text = "Control Setup";
				this.ClientSize = new Drawing.Size( 420, 340 );
				this.FormBorderStyle  = Forms.FormBorderStyle.FixedDialog;
				this.MinimizeBox = false;
				this.MaximizeBox = false;
				this.TabControl.Bounds = new Drawing.Rectangle( ClientRectangle.Left + 6, ClientRectangle.Top + 4, ClientRectangle.Width - 10, ClientRectangle.Height - 36 );
				this.Controls.Add( TabControl );
				this.OK_Button.Text = "OK";
				this.OK_Button.Bounds = new Drawing.Rectangle( ClientRectangle.Right - 84, ClientRectangle.Bottom - 28, 80, 24 );
				this.OK_Button.Click += OK_ButtonClickEvent;
				this.Controls.Add( OK_Button );
				//this.AcceptButton = OK_Button;
				foreach( IController CurrentController in Console.ControllerArray )
				{
					this.TabControl.TabPages.Add( new ControllerTabPage( TabControl, InputDevice, CurrentController ) );
				}
				return;
			}
			
			private void OK_ButtonClickEvent( object Sender, EventArgs Arguments )
			{
				Close();
				return;
			}
			
		}
		
	//}
	
}

